package com.tad.gapps.ejb;

import java.util.Date;
import java.util.Random;

import javax.annotation.Named;
import javax.context.Dependent;
import javax.context.SessionScoped;
import javax.ejb.Local;
import javax.ejb.Stateful;

import org.jboss.ejb3.annotation.Clustered;

@Named("enterpriseActionBean")
@SessionScoped
@Stateful
@Local
@Clustered
public class EnterpriseActionBean implements EnterpriseAction,java.io.Serializable {
	private String someActionValue = null;
	/* (non-Javadoc)
	 * @see com.tad.gapps.ejb.EnterpriseAction#getSomeActionValue()
	 */
	public String getSomeActionValue() {
		if(someActionValue == null) myAction();
		return someActionValue;
	}
	/* (non-Javadoc)
	 * @see com.tad.gapps.ejb.EnterpriseAction#setSomeActionValue(java.lang.String)
	 */
	public void setSomeActionValue(String someActionValue) {
		this.someActionValue = someActionValue;
	}
	
	/* (non-Javadoc)
	 * @see com.tad.gapps.ejb.EnterpriseAction#getSomeRandomDate()
	 */
	public Date getSomeRandomDate() {
		try{
			Random r = new Random();
			long l = r.nextLong();
			return new Date(l);
		} catch (RuntimeException e) {
			e.printStackTrace(System.err);
			return new Date();
		}
	}
	
	/* (non-Javadoc)
	 * @see com.tad.gapps.ejb.EnterpriseAction#myAction()
	 */
	public String myAction() {
		if(someActionValue == null || someActionValue.equals("dodefault")) {
			someActionValue = this.getClass().getCanonicalName();
		} else {
			someActionValue = someActionValue.toUpperCase();
		}
		return "page2.xhtml";
	}
	@Override
	public void remove() {
		System.err.println("Removing an instance of "+this.getClass().getCanonicalName());
	}
}
